%macro createBuffer (width, height);
  &jdsgi..callVoidMethod ('createBuffer', &width, &height)
%mend;

%macro setColor (r,g,b);
  &jdsgi..callVoidMethod ('setColor', &r,&g,&b)
%mend;

%macro fillRect (x,y, width,height);
  &jdsgi..callVoidMethod ('fillRect', &x,&y,&width,&height)
%mend;

%macro drawOval (x,y, width,height);
  &jdsgi..callVoidMethod ('drawOval', &x,&y,&width,&height)
%mend;

%macro fillOval (x,y, width,height);
  &jdsgi..callVoidMethod ('fillOval', &x,&y,&width,&height)
%mend;

%macro saveAs (type, filename, savedAs);
  &jdsgi..callStringMethod ('saveAs', &type,&filename,&savedAs)
%mend;

%macro showTM (title, message);
  &jdsgi..callVoidMethod ('show', &title, &message);
%mend;

%macro canvas_create (javaobj, width, height, r,g,b);
  %global jdsgi;
  %let jdsgi = &javaobj;
  declare javaobj &jdsgi. ('SUGI30/Graphics');
  &jdsgi..exceptionDescribe(1);
  %createBuffer (&width, &height);
  %setColor (&r,&g,&b);
  %fillRect (0,0,&width,&height);
  %setColor (0,0,0);
%mend;

%macro canvas_delete();
  &jdsgi..delete();
  %symdel jdsgi;
%mend;

*options mprint symbolgen mtrace;

data _null_;
  length savedAs $200;

  %canvas_create (_g, 200,200, 255,255,255);
  %setColor (255,0,0);
  %drawOval (1,1,198,198);
  %fillOval (80,80,40,40);
  %saveAs ('png', 'target2.png', savedAs);
  %showTM (savedAs, cat('Drawing buffer','0a'x,'Drawn with Macros.'));
  %canvas_delete();
run;

proc javainfo;
run;